CREATE SCHEMA JAVA_REVIEW AUTHORIZATION "default";

CREATE TABLE JAVA_REVIEW.REGIONS (
	REGION_ID SERIAL NOT NULL ,
	REGION_NAME VARCHAR NOT NULL,
	CONSTRAINT REGIONS_PK PRIMARY KEY (REGION_ID),
	CONSTRAINT REGIONS_UNIQUE UNIQUE (REGION_NAME)
);
--CREATE UNIQUE INDEX PRIMARY_KEY_6 ON JAVA_REVIEW.REGIONS (REGION_ID);
--CREATE UNIQUE INDEX REGIONS_UNIQUE_INDEX_6 ON JAVA_REVIEW.REGIONS (REGION_NAME);

CREATE TABLE JAVA_REVIEW.COUNTRIES (
	COUNTRY_ID SERIAL NOT NULL ,
	COUNTRY_NAME VARCHAR NOT NULL,
	REGION_ID INTEGER,
	CONSTRAINT COUNTRIES_UNIQUE UNIQUE (COUNTRY_NAME),
	CONSTRAINT COUNTRIES_PK PRIMARY KEY (COUNTRY_ID),
	CONSTRAINT COUNTRIES_REGIONS_FK FOREIGN KEY (REGION_ID) REFERENCES JAVA_REVIEW.REGIONS(REGION_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
--CREATE INDEX COUNTRIES_COUNTRY_NAME_IDX ON JAVA_REVIEW.COUNTRIES (COUNTRY_NAME);
--CREATE INDEX COUNTRIES_REGIONS_FK_INDEX_F ON JAVA_REVIEW.COUNTRIES (REGION_ID);
--CREATE UNIQUE INDEX PRIMARY_KEY_F ON JAVA_REVIEW.COUNTRIES (COUNTRY_ID);

CREATE TABLE JAVA_REVIEW.LOCATIONS (
	LOCATION_ID SERIAL NOT NULL ,
	COUNTRY_ID INTEGER,
	ADDRESS VARCHAR,
	POSTAL_CODE VARCHAR,
	CITY VARCHAR,
	STATE VARCHAR,
	CONSTRAINT LOCATIONS_PK PRIMARY KEY (LOCATION_ID),
	CONSTRAINT LOCATIONS_COUNTRIES_FK FOREIGN KEY (COUNTRY_ID) REFERENCES JAVA_REVIEW.COUNTRIES(COUNTRY_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
CREATE INDEX IDX_LOCATION_DETAILS ON JAVA_REVIEW.LOCATIONS (ADDRESS, POSTAL_CODE, CITY, STATE);
--CREATE INDEX LOCATIONS_COUNTRIES_FK_INDEX_5 ON JAVA_REVIEW.LOCATIONS (COUNTRY_ID);
--CREATE UNIQUE INDEX PRIMARY_KEY_5 ON JAVA_REVIEW.LOCATIONS (LOCATION_ID);

CREATE TABLE JAVA_REVIEW.WAREHOUSES (
	WAREHOUSE_ID SERIAL NOT NULL ,
	WAREHOUSE_NAME VARCHAR NOT NULL,
	LOCATION_ID INTEGER,
	CONSTRAINT WAREHOUSES_PK PRIMARY KEY (WAREHOUSE_ID),
	CONSTRAINT WAREHOUSES_LOCATIONS_FK FOREIGN KEY (LOCATION_ID) REFERENCES JAVA_REVIEW.LOCATIONS(LOCATION_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
CREATE INDEX IDX_WAREHOUSE_NAME ON JAVA_REVIEW.WAREHOUSES (WAREHOUSE_NAME);
--CREATE UNIQUE INDEX PRIMARY_KEY_B ON JAVA_REVIEW.WAREHOUSES (WAREHOUSE_ID);
--CREATE INDEX WAREHOUSES_LOCATIONS_FK_INDEX_B ON JAVA_REVIEW.WAREHOUSES (LOCATION_ID);

CREATE TABLE JAVA_REVIEW.PRODUCT_CATEGORIES (
	CATEGORY_ID SERIAL NOT NULL ,
	CATEGORY_NAME VARCHAR NOT NULL,
	CONSTRAINT PRODUCT_CATEGORIES_PK PRIMARY KEY (CATEGORY_ID)
);
CREATE INDEX IDX_CATEGORY_NAME on JAVA_REVIEW.PRODUCT_CATEGORIES (CATEGORY_NAME);
--CREATE UNIQUE INDEX PRIMARY_KEY_5A ON JAVA_REVIEW.PRODUCT_CATEGORIES (CATEGORY_ID);

CREATE TABLE JAVA_REVIEW.PRODUCTS (
	PRODUCT_ID SERIAL NOT NULL ,
	PRODUCT_NAME VARCHAR NOT NULL,
	DESCRIPTION VARCHAR,
	STANDARD_COST DECIMAL DEFAULT 0.00,
	LIST_PRICE DECIMAL DEFAULT 0.00,
	CATEGORY_ID INTEGER,
	CONSTRAINT PRODUCTS_PK PRIMARY KEY (PRODUCT_ID),
	CONSTRAINT PRODUCTS_PRODUCT_CATEGORIES_FK FOREIGN KEY (CATEGORY_ID) REFERENCES JAVA_REVIEW.PRODUCT_CATEGORIES(CATEGORY_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
CREATE INDEX PRODUCTS_PRODUCT_ID_IDX ON JAVA_REVIEW.PRODUCTS (PRODUCT_NAME,LIST_PRICE);
--CREATE UNIQUE INDEX PRIMARY_KEY_F2 ON JAVA_REVIEW.PRODUCTS (PRODUCT_ID);
--CREATE INDEX PRODUCTS_PRODUCT_CATEGORIES_FK_INDEX_F ON JAVA_REVIEW.PRODUCTS (CATEGORY_ID);

CREATE TABLE JAVA_REVIEW.CUSTOMERS (
	CUSTOMER_ID SERIAL NOT NULL,
	"NAME" VARCHAR NOT NULL,
	ADDRESS VARCHAR NOT NULL,
	WEBSITE VARCHAR NULL,
	CREDIT_LIMIT VARCHAR NOT NULL,
	CONSTRAINT CUSTOMERS_PK PRIMARY KEY (CUSTOMER_ID)
);
CREATE INDEX CUSTOMERS_NAME_IDX ON JAVA_REVIEW.CUSTOMERS (NAME);
--CREATE UNIQUE INDEX PRIMARY_KEY_62 ON JAVA_REVIEW.CUSTOMERS (CUSTOMER_ID);

CREATE TABLE JAVA_REVIEW.EMPLOYEES (
	EMPLOYEE_ID SERIAL NOT NULL,
	FIRST_NAME VARCHAR NOT NULL,
	LAST_NAME VARCHAR NOT NULL,
	EMAIL VARCHAR NOT NULL,
	PHONE VARCHAR NOT NULL,
	HIRE_DATE DATE NOT NULL,
	MANAGER_ID INTEGER,
	JOB_TITLE VARCHAR NULL,
	CONSTRAINT EMPLOYEES_PK PRIMARY KEY (EMPLOYEE_ID),
	CONSTRAINT EMPLOYEES_EMPLOYEES_FK FOREIGN KEY (MANAGER_ID) REFERENCES JAVA_REVIEW.EMPLOYEES(EMPLOYEE_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
CREATE INDEX IDX_MANAGER_OPTS ON JAVA_REVIEW.EMPLOYEES (FIRST_NAME, LAST_NAME, JOB_TITLE);
--CREATE INDEX EMPLOYEES_EMPLOYEES_FK_INDEX_4 ON JAVA_REVIEW.EMPLOYEES (MANAGER_ID);
--CREATE UNIQUE INDEX PRIMARY_KEY_4 ON JAVA_REVIEW.EMPLOYEES (EMPLOYEE_ID);

CREATE TABLE JAVA_REVIEW.ORDERS (
	ORDER_ID SERIAL NOT NULL,
	CUSTOMER_ID INTEGER NOT NULL,
	STATUS VARCHAR NOT NULL,
	SALESMAN_ID INTEGER NOT NULL,
	ORDER_DATE DATE NOT NULL,
	CONSTRAINT ORDERS_PK PRIMARY KEY (ORDER_ID),
	CONSTRAINT ORDERS_CUSTOMERS_FK FOREIGN KEY (CUSTOMER_ID) REFERENCES JAVA_REVIEW.CUSTOMERS(CUSTOMER_ID) ON DELETE SET NULL ON UPDATE CASCADE,
	CONSTRAINT ORDERS_EMPLOYEES_FK FOREIGN KEY (SALESMAN_ID) REFERENCES JAVA_REVIEW.EMPLOYEES(EMPLOYEE_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
--CREATE INDEX ORDERS_CUSTOMERS_FK_INDEX_8 ON JAVA_REVIEW.ORDERS (CUSTOMER_ID);
--CREATE INDEX ORDERS_EMPLOYEES_FK_INDEX_8 ON JAVA_REVIEW.ORDERS (SALESMAN_ID);
--CREATE UNIQUE INDEX PRIMARY_KEY_8 ON JAVA_REVIEW.ORDERS (ORDER_ID);

CREATE TABLE JAVA_REVIEW.ORDER_ITEMS (
	ORDER_ID INTEGER NOT NULL,
	ITEM_ID SERIAL NOT NULL ,
	PRODUCT_ID INTEGER NOT NULL,
	QUANTITY INTEGER DEFAULT 0,
	UNIT_PRICE DECIMAL DEFAULT 0.00,
	CONSTRAINT ORDER_ITEMS_PK PRIMARY KEY (ITEM_ID),
	CONSTRAINT ORDER_ITEMS_ORDERS_FK FOREIGN KEY (ORDER_ID) REFERENCES JAVA_REVIEW.ORDERS(ORDER_ID) ON DELETE CASCADE ON UPDATE CASCADE,
	CONSTRAINT ORDER_ITEMS_PRODUCTS_FK FOREIGN KEY (PRODUCT_ID) REFERENCES JAVA_REVIEW.PRODUCTS(PRODUCT_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
--CREATE INDEX ORDER_ITEMS_ORDERS_FK_INDEX_2 ON JAVA_REVIEW.ORDER_ITEMS (ORDER_ID);
--CREATE INDEX ORDER_ITEMS_PRODUCTS_FK_INDEX_2 ON JAVA_REVIEW.ORDER_ITEMS (PRODUCT_ID);
--CREATE UNIQUE INDEX PRIMARY_KEY_2 ON JAVA_REVIEW.ORDER_ITEMS (ITEM_ID);

CREATE TABLE JAVA_REVIEW.CONTACTS (
	CONTACT_ID SERIAL NOT NULL ,
	FIRST_NAME VARCHAR NOT NULL,
	LAST_NAME VARCHAR NOT NULL,
	EMAIL VARCHAR NOT NULL,
	PHONE VARCHAR NOT NULL,
	CUSTOMER_ID INTEGER,
	CONSTRAINT CONTACTS_PK PRIMARY KEY (CONTACT_ID),
	CONSTRAINT CONTACTS_CUSTOMERS_FK FOREIGN KEY (CUSTOMER_ID) REFERENCES JAVA_REVIEW.CUSTOMERS(CUSTOMER_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
CREATE INDEX IDX_CONTACT_DETAILS ON JAVA_REVIEW.CONTACTS (FIRST_NAME, LAST_NAME, EMAIL, PHONE);
--CREATE INDEX CONTACTS_CUSTOMERS_FK_INDEX_C ON JAVA_REVIEW.CONTACTS (CUSTOMER_ID);
--CREATE UNIQUE INDEX PRIMARY_KEY_C ON JAVA_REVIEW.CONTACTS (CONTACT_ID);

CREATE TABLE JAVA_REVIEW.INVENTORIES (
    INVENTORY_ID SERIAL NOT NULL ,
	PRODUCT_ID INTEGER,
	WAREHOUSE_ID INTEGER,
	QUANTITY INTEGER DEFAULT 0 NOT NULL,
	CONSTRAINT INVENTORIES_PK PRIMARY KEY (INVENTORY_ID),
	CONSTRAINT INVENTORIES_PRODUCTS_FK FOREIGN KEY (PRODUCT_ID) REFERENCES JAVA_REVIEW.PRODUCTS(PRODUCT_ID) ON DELETE SET NULL ON UPDATE CASCADE,
    CONSTRAINT INVENTORIES_WAREHOUSES_FK FOREIGN KEY (WAREHOUSE_ID) REFERENCES JAVA_REVIEW.WAREHOUSES(WAREHOUSE_ID) ON DELETE SET NULL ON UPDATE CASCADE
);
--CREATE INDEX INVENTORIES_PRODUCTS_FK_INDEX_6 ON JAVA_REVIEW.INVENTORIES (PRODUCT_ID);
--CREATE INDEX INVENTORIES_WAREHOUSES_FK_INDEX_6 ON JAVA_REVIEW.INVENTORIES (WAREHOUSE_ID);
--CREATE UNIQUE INDEX PRIMARY_KEY_64 ON JAVA_REVIEW.INVENTORIES (INVENTORY_ID);




